Microsoft Multipath I/O (MPIO)

Microsoft Multipath I/O (MPIO) is a framework that allows you to develop multipath solutions that contain the hardware-specific information needed to optimize connectivity with your storage arrays. This help file explains some of the MPIO interface and features.

This help file includes the following topics:

  • Add or Remove MPIO Support

  • Multipath Device Discovery

  • Install or Uninstall a DSM

  • Capture the System's Current MPIO Configuration

  • MPIO Policies

  • MPIO Path Details

  • DSM Details


Add or Remove MPIO Support

For Multipath I/O (MPIO) to manage a device, you must first add the hardware ID that corresponds to the device that you want to add to MPIO.

You can view the hardware IDs of devices that are currently managed by MPIO on the Discover Multi-Paths tab. The ability to view a device is based on its hardware ID, which combines a vendor’s name and a product string that matches a device ID that is maintained by MPIO in its supported device list. Every Device Specific Module (DSM) specifies a product string in its .inf file at the time of installation.

To specify another MPIO device, click Add, and then in the Add MPIO Support dialog box, enter the device information.

Note

The vendor and product IDs are provided by the storage provider, and are specific to each type of hardware.

To remove a device, select it from the list, and then click Remove.

See Also

  • Microsoft Multipath I/O (MPIO)


Multipath Device Discovery

From the Discover Multi-Paths tab, you can add devices that are available on your network. You can also determine if multiple instances of a device are represented by the same storage unit. For such devices, their hardware IDs are listed.

If you are using Microsoft Multipath I/O (MPIO) with iSCSI Initiator, click Add support for iSCSI devices. (This may require the computer to be rebooted.)

Note

Adding support for iSCSI allows the Microsoft Device Specific Module (MSDSM) to claim all iSCSI devices for MPIO, which first requires a connection to an iSCSI Target.

See Also


Install or Uninstall a DSM

Many storage arrays that are active-active and SPC-3 compliant will work using the Microsoft Multipath I/O (MPIO) Device Specific Module (DSM). Some storage array partners also provide their own DSMs to use with the Microsoft MPIO architecture. When installing a non-Microsoft DSM, if that DSM does not have its own setup package, you can install compliant non-Microsoft DSMs by browsing for the DSM’s .inf file, and then clicking Install. You can also uninstall a non-Microsoft DSM by clicking Uninstall.

See Also


Capture the System's Current MPIO Configuration

This feature allows you to save the current Microsoft Multipath I/O (MPIO) configuration to a text file that can be reviewed for troubleshooting or comparison purposes at a later time.

The report includes information on the Device Specific Module (DSM) that is being used, the number of paths, and the path state.

You can also save this configuration at a command prompt using the mpclaim command. For information about how to use the mpclaim command, in an elevated command prompt, run mpclaim /?.

See Also


MPIO Policies

You can choose from the following Microsoft Multipath I/O (MPIO) policies.

Fail Over Only - Policy that does not perform load balancing. This policy uses a single active path, and the rest of the paths are standby paths. The active path is used for sending all I/O. If the active path fails, then one of the standby paths is used. When the path that failed is reactivated or reconnected, the standby path that was activated returns to standby.

Round Robin - Load balancing policy that allows the Device Specific Module (DSM) to use all available paths for MPIO in a balanced way. This is the default policy that is chosen when the storage controller follows the active-active model and the management application does not specifically choose a load-balancing policy.

Round Robin with Subset - Load balancing policy that allows the application to specify a set of paths to be used in a round robin fashion, and with a set of standby paths. The DSM uses paths from a primary pool of paths for processing requests as long as at least one of the paths is available. The DSM uses a standby path only when all the primary paths fail. For example, given 4 paths: A, B, C, and D, paths A, B, and C are listed as primary paths and D is the standby path. The DSM chooses a path from A, B, and C in round robin fashion as long as at least one of them is available. If all three paths fail, the DSM uses D, the standby path. If paths A, B, or C become available, the DSM stops using path D and switches to the available paths among A, B, and C.

Least Queue Depth - Load balancing policy that sends I/O down the path with the fewest currently outstanding I/O requests. For example, consider that there is one I/O that is sent to LUN 1 on Path 1, and the other I/O is sent to LUN 2 on Path 1. The cumulative outstanding I/O on Path 1 is 2, and on Path 2, it is 0. Therefore, the next I/O for either LUN will process on Path 2.

Weighted Paths - Load balancing policy that assigns a weight to each path. The weight indicates the relative priority of a given path. The larger the number, the lower ranked the priority. The DSM chooses the least-weighted path from among the available paths.

Least Blocks - Load balancing policy that sends I/O down the path with the least number of data blocks currently being processed. For example, consider that there are two I/Os: one is 10 bytes and the other is 20 bytes. Both are in process on Path 1, and both have completed Path 2. The cumulative outstanding amount of I/O on Path 1 is 30 bytes. On Path 2, it is 0. Therefore, the next I/O will process on Path 2.

MPCLAIM command

You can also use the mpclaim command at a command prompt to set the MPIO load balancing policy for a single disk, all disks, or if you preconfigure the policy, you can set the default policy that is applied to all disks that are discovered with a particular hardware ID. Additionally, you may display hardware IDs for all devices that are currently detected. For information about how to use the mpclaim command, in a command prompt, type mpclaim /?, and then press ENTER.

Note

Using the mpclaim command to set an MPIO load balancing policy requires that the devices are managed by the Microsoft DSM.

See Also


MPIO Path Details

This dialog box displays information about the currently selected Microsoft Multipath I/O (MPIO) path. The information includes the path state and details about the configuration path. It also includes basic statistical information about the path usage, such as the number of reads or writes, and the number of bytes read or written to on the selected path.

See Also


DSM Details

You can install or uninstall a vendor-specific Device Specific Module (DSM) through the Multipath I/O (MPIO) control panel applet if the vendor DSM does not have its own installation program.

For more information about installing and using a vendor DSM, refer to the setup documentation that is included with the vendor DSM installation package.

See Also